Compatibility issue with Redmine 1.4.*

28 Apr 2012 09:19 - Alexander van der Mey

Status: Closed Start date: 28 Apr 2012

Priority: Critical Due date: 04 Oct 2012

Assignee: Andriy Lesyuk % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: 0.1.0   

Redmine version: 1.4.x External issue:  

Description

Thanks for developing this awesome plugin. I’ve been using it for a while now on my redmine instance. I recently upgraded to

redmine 1.4.1, but forgot to check compability for my active plugins on beforehand. I upgraded both the sidebar plugin and the

redmine-settings plugin to the latest svn, and ran “rake db:migrate:plugins RAILS_ENV=production” after the upgrade. The sidebar

still works after the upgrade, but accessing the project settings tab or the administration menu does not.

The following errors are produced upon accessing them:

ActionView::TemplateError (No route matches {:controller=>"sidebar", :id=>#<Project id: 1, name: "

Gummi", description: "Gummi is a LaTeX editor for the Linux platform, wri...", homepage: "", is_pu

blic: true, parent_id: nil, created_on: "2009-10-27 08:52:23", updated_on: "2012-02-09 22:27:07", 

identifier: "gummi", status: 1, lft: 1, rgt: 2>, :action=>"edit"}) on line #58 of vendor/plugins/s

idebar/app/views/projects/settings/_sidebar.rhtml:

55: //]]>

56: </script>

57: 

58: <% form_tag({ :controller => 'sidebar', :action => 'edit', :id => @project }, :id => 'sidebar-

content-form', :class => 'tabular') do %>

59: 

60: <div class="box">

61: <p>

    vendor/plugins/sidebar/app/views/projects/settings/_sidebar.rhtml:58:in `_run_rhtml_vendor47pl

ugins47sidebar47app47views47projects47settings47_sidebar46rhtml_locals_object_sidebar_tab'

    app/views/common/_tabs.html.erb:24

    app/views/common/_tabs.html.erb:23:in `each'

    app/views/common/_tabs.html.erb:23

    app/helpers/application_helper.rb:231:in `render_tabs'

    app/views/projects/settings.html.erb:3

    thin (1.2.11) lib/thin/connection.rb:84:in `pre_process'

    thin (1.2.11) lib/thin/connection.rb:82:in `catch'

    thin (1.2.11) lib/thin/connection.rb:82:in `pre_process'

    thin (1.2.11) lib/thin/connection.rb:57:in `process'

    thin (1.2.11) lib/thin/connection.rb:42:in `receive_data'

    eventmachine (0.12.10) lib/eventmachine.rb:256:in `run_machine'

    eventmachine (0.12.10) lib/eventmachine.rb:256:in `run'

    thin (1.2.11) lib/thin/backends/base.rb:61:in `start'

    thin (1.2.11) lib/thin/server.rb:159:in `start'

    thin (1.2.11) lib/thin/controllers/controller.rb:86:in `start'

    thin (1.2.11) lib/thin/runner.rb:185:in `send'

    thin (1.2.11) lib/thin/runner.rb:185:in `run_command'

    thin (1.2.11) lib/thin/runner.rb:151:in `run!'

    thin (1.2.11) bin/thin:6

    /usr/bin/thin:8:in `load'

    /usr/bin/thin:8
ActionView::TemplateError (No route matches {:controller=>"global_sidebar", :action=>"pages"}) on 

line #3 of app/views/admin/_menu.html.erb:

1: <div id="admin-menu">

2:   <ul>

3:     <%= render_menu :admin_menu %>

4:   </ul>

5: </div>

    lib/redmine/menu_manager.rb:150:in `render_single_menu_node'

    lib/redmine/menu_manager.rb:102:in `render_menu_node'

    lib/redmine/menu_manager.rb:91:in `render_menu'

    lib/redmine/menu_manager.rb:168:in `menu_items_for'

    lib/redmine/menu_manager.rb:165:in `each'

    lib/redmine/menu_manager.rb:165:in `menu_items_for'

    lib/redmine/menu_manager.rb:90:in `render_menu'

    app/views/admin/_menu.html.erb:3

    app/views/admin/index.html.erb:5

    thin (1.2.11) lib/thin/connection.rb:84:in `pre_process'

    thin (1.2.11) lib/thin/connection.rb:82:in `catch'

    thin (1.2.11) lib/thin/connection.rb:82:in `pre_process'

    thin (1.2.11) lib/thin/connection.rb:57:in `process'

    thin (1.2.11) lib/thin/connection.rb:42:in `receive_data'

    eventmachine (0.12.10) lib/eventmachine.rb:256:in `run_machine'

    eventmachine (0.12.10) lib/eventmachine.rb:256:in `run'

    thin (1.2.11) lib/thin/backends/base.rb:61:in `start'

    thin (1.2.11) lib/thin/server.rb:159:in `start'

    thin (1.2.11) lib/thin/controllers/controller.rb:86:in `start'

    thin (1.2.11) lib/thin/runner.rb:185:in `send'

    thin (1.2.11) lib/thin/runner.rb:185:in `run_command'

    thin (1.2.11) lib/thin/runner.rb:151:in `run!'

    thin (1.2.11) bin/thin:6

    /usr/bin/thin:8:in `load'

    /usr/bin/thin:8
Thanks in advance!

History

#1 - 13 May 2012 12:44 - Andriy Lesyuk

- Status changed from New to Open

- Assignee set to Andriy Lesyuk

- Priority changed from Normal to Critical

#2 - 24 Jun 2012 20:58 - Ismail SEZEN

The issue is still valid for Redmine v1.4.4.

#3 - 09 Sep 2012 10:27 - Alexander van der Mey

Would you be so kind to provide an estimate as to when you are planning to look into this issue? Your wonderful plug-in has become a crucial part of

my tracker, and as such, this bug is blocking the upgrade to newer versions of Redmine. I could look into it myself, but I am unfamiliar with the

redmine code, so that would have to wait until I have time for it.

#4 - 09 Sep 2012 12:05 - Andriy Lesyuk

Alexander van der Mey wrote:

Would you be so kind to provide an estimate as to when you are planning to look into this issue? Your wonderful plug-in has become a crucial

part of my tracker, and as such, this bug is blocking the upgrade to newer versions of Redmine. I could look into it myself, but I am unfamiliar

with the redmine code, so that would have to wait until I have time for it.
Unfortunately I can’t be exact... Right now I’m working on finishing adding support for 2.0.x for other plugins (they are too related between

themselves). The Sidebar plugin is going to be next. I guess this plugin should be fixed in a month... But practice shows that I can be wrong.

Sorry, too much work on other projects...  Doing my best.

#5 - 09 Sep 2012 17:03 - Alexander van der Mey

Andriy Lesyuk wrote:

Alexander van der Mey wrote:

Would you be so kind to provide an estimate as to when you are planning to look into this issue? Your wonderful plug-in has become a

crucial part of my tracker, and as such, this bug is blocking the upgrade to newer versions of Redmine. I could look into it myself, but I am

unfamiliar with the redmine code, so that would have to wait until I have time for it.

 

Unfortunately I can’t be exact... Right now I’m working on finishing adding support for 2.0.x for other plugins (they are too related between

themselves). The Sidebar plugin is going to be next. I guess this plugin should be fixed in a month... But practice shows that I can be wrong.

Sorry, too much work on other projects...  Doing my best.

 

I know what having too much work feels like.. 

Just happy to hear it is still on your radar. Thanks again for creating all these great plugins!

#6 - 26 Sep 2012 13:29 - Alexander van der Mey

- File redmine14-explicit-routes.patch added

I have briefly looked into the issue. Note that I have no prior ruby/redmine experience, so please correct me if I am wrong:

The default routes have been removed in Redmine 1.4 and above, and as such plugins must define them explicitly. The attached patch adds a file

config/routes.rb that does as such for the sidebar plugin. I hope the routes stated in this file are both valid and complete. I was able to successfully

load, edit and save changes to the sidebar on Redmine 1.4.4. after applying this patch. Redmine 2.* was not tested, but should not cause additional

challenges.
#7 - 27 Sep 2012 20:02 - Andriy Lesyuk

- Status changed from Open to In Progress

- Target version set to 0.1.0

#8 - 01 Oct 2012 11:54 - Andriy Lesyuk

- % Done changed from 0 to 80

I’m very sorry, Alexander, for the delay!

I have started working on this plugin and already applied some changes... I’m not sure if they are enough though. Would be happy if you could test

changes in SVN.

Also thank you very much for the help with routes! I applied not all of them though. Thus, the route for /sidebar/settings is needed because Redmine

1.4.x also requires :id for redirect_to...

#9 - 04 Oct 2012 21:45 - Andriy Lesyuk

- Due date set to 04 Oct 2012

- Status changed from In Progress to Closed

- % Done changed from 80 to 100

Files

redmine14-explicit-routes.patch 559 Bytes 26 Sep 2012 Alexander van der Mey
